LibreOffice: XResourceId Interface Reference

LibreOffice LibreOffice 6.4 SDK API Reference

Public Member Functions | List of all members
XResourceId Interface Reference

A resource id uses a set of URLs to unambiguously specify a resource of the drawing framework. More...

`import"XResourceId.idl";`

Inheritance diagram for XResourceId:

## Public Member Functions
string | getResourceURL ()
| Return the URL of the resource. More...
com::sun::star::util::URL | getFullResourceURL ()
| Return a URL object of the resource URL that may contain arguments. More...
boolean | hasAnchor ()
| Return whether there is a non-empty anchor URL. More...
XResourceId | getAnchor ()
| Return a new XResourceId that represents the anchor resource. More...
sequence< string > | getAnchorURLs ()
| Return the, possibly empty, list of anchor URLs. More...
string | getResourceTypePrefix ()
| Return the type prefix of the resource URL. More...
short | compareTo ([in] XResourceId xId)
| Compare the called XResourceId object with the given one. More...
boolean | isBoundTo ([in] XResourceId xAnchorId, [in] AnchorBindingMode eMode)
| Return whether the anchor of the called resource id object represents the same resource as the given object. More...
boolean | isBoundToURL ([in] string AnchorURL, [in] AnchorBindingMode eMode)
| Return whether the anchor of the called resource id object represents the same resource as the given anchor URL. More...
XResourceId | clone ()
| Return a copy of the called resource id. More...

## Detailed Description

A resource id uses a set of URLs to unambiguously specify a resource of the drawing framework.

Resources of the drawing framework are panes, views, tool bars, and command groups. One URL describes the type of the actual resource. A sequence of URLs (typically one, sometimes two) specifies its anchor, the resource it is bound to. The anchor typically is a pane (for views), or it is empty (for panes).

The resource URL may be empty. In this case the anchor is empty, too. Such an empty resource id does not describe a resource but rather the absence of one. Instead of an empty XResourceId object an empty reference can be used in many places.

The resource URL may have arguments that are passed to the factory method on its creation. Arguments are only available through the getFullResourceURL(). The getResourceURL() method strips them away.

## Member Function Documentation

## ◆ clone()

XResourceId clone | ( |  | ) |

Return a copy of the called resource id.

The caller becomes the owner of the new object.

## ◆ compareTo()

short compareTo | ( | [in] XResourceId | xId | ) |

Compare the called XResourceId object with the given one.

The two resource ids A and B are compared so that if A<B (return value is -1) then either A and B are unrelated or A is a direct or indirect anchor of B.

The algorithm for this comparison is quite simple. It uses a double lexicographic ordering. On the lower level individual URLs are compared via the lexicographic order defined on strings. On the higher level two resource ids are compared via a lexicographic order defined on the URLS. So when there are two resource ids A1.A2 (A1 being the anchor of A2) and B1.B2 then A1.A2<B1.B2 when A1<B1 or A1==B1 and A2<B2. Resource ids may have different lengths: A1 < B1.B2 when A1<B1 or A1==B1 (anchors first then resources linked to them.

Parameters

  xId | The resource id to which the called resource id is compared.

Returns
  Returns 0 when the called resource id is equivalent to the given resource id. Returns `-1` or `+1` when the two compared resource ids differ.

## ◆ getAnchor()

XResourceId getAnchor | ( |  | ) |

Return a new XResourceId that represents the anchor resource.

## ◆ getAnchorURLs()

sequence<string> getAnchorURLs | ( |  | ) |

Return the, possibly empty, list of anchor URLs.

The URLs are ordered so that the one in position 0 is the direct anchor of the resource, while the one in position i+1 is the direct anchor of the one in position i.

## ◆ getFullResourceURL()

com::sun::star::util::URL getFullResourceURL | ( |  | ) |

Return a URL object of the resource URL that may contain arguments.

## ◆ getResourceTypePrefix()

string getResourceTypePrefix | ( |  | ) |

Return the type prefix of the resource URL.

This includes all up to and including the second slash.

## ◆ getResourceURL()

string getResourceURL | ( |  | ) |

Return the URL of the resource.

Arguments supplied on creation are stripped away. Use getFullResourceURL() to access them.

## ◆ hasAnchor()

boolean hasAnchor | ( |  | ) |

Return whether there is a non-empty anchor URL.

When this method returns `FALSE` then getAnchorURLs() will return an empty list.

## ◆ isBoundTo()

boolean isBoundTo | ( | [in] XResourceId | xAnchorId,
|  | [in] AnchorBindingMode | eMode
| ) |  |

Return whether the anchor of the called resource id object represents the same resource as the given object.

Note that not only the anchor of the given object is taken into account. The whole object, including the resource URL, is interpreted as anchor resource.

Parameters

  xAnchorId | The resource id of the anchor.
  eMode | This mode specifies how the called resource has to be bound to the given anchor in order to have this function return `TRUE`.

If eMode is DIRECT then the anchor of the called resource id has to be identical to the given anchor. If eMode is INDIRECT then the given anchor has to be a part of the anchor of the called resource.

## ◆ isBoundToURL()

boolean isBoundToURL | ( | [in] string | AnchorURL,
|  | [in] AnchorBindingMode | eMode
| ) |  |

Return whether the anchor of the called resource id object represents the same resource as the given anchor URL.

This is a convenience variant of the isBoundTo() function that can also be seen as an optimization for the case that the anchor consists of exactly one URL.

Parameters

  AnchorURL | The resource URL of the anchor.
  eMode | This mode specifies how the called resource has to be bound to the given anchor in order to have this function return. See the description of isBoundTo() for more information.

The documentation for this interface was generated from the following file:

- com/sun/star/drawing/framework/XResourceId.idl